%bcond_with bootstrap

Summary:        RPM Macros and Utilities for Node.js Packaging
Name:           nodejs-packaging
Version:        2022.10
Release:        5%{?dist}
License:        MIT
URL:            https://fedoraproject.org/wiki/Node.js/Packagers
Source0001:     LICENSE
Source0002:     README.md
Source0003:     macros.nodejs
Source0004:     multiver_modules
Source0005:     nodejs-fixdep
Source0006:     nodejs-setversion
Source0007:     nodejs-symlink-deps
Source0008:     nodejs.attr
Source0009:     nodejs.prov
Source0010:     nodejs.req
Source0011:     nodejs_abi.attr
Source0012:     nodejs_abi.req
Source0013:     nodejs-packaging-bundler
Source0014:     test.tar.gz

BuildRequires:  python3

Requires:       /usr/bin/node
Requires:       system-rpm-config

BuildArch:      noarch

%description
This package contains RPM macros and other utilities useful for packaging
Node.js modules and applications in RPM-based distributions.

%package bundler
Summary:      Bundle a node.js application dependencies
%if %{without bootstrap}
Requires:       npm
%endif
Requires:       coreutils, findutils, jq

%description bundler
nodejs-packaging-bundler bundles a node.js application node_module dependencies
It gathers the application tarball.
It generates a runtime (prod) tarball with runtime node_module dependencies
It generates a testing (dev) tarball with node_module dependencies for testing
It generates a bundled license file that gets the licenses in the runtime
dependency tarball



%prep
pushd %{_topdir}/BUILD
cp -da %{_sourcedir}/* .
tar xvf test.tar.gz
popd



%build



%install
install -Dpm0644 macros.nodejs %{buildroot}%{_rpmconfigdir}/macros.d/macros.nodejs
install -Dpm0644 nodejs.attr %{buildroot}%{_rpmconfigdir}/fileattrs/nodejs.attr
install -Dpm0644 nodejs_abi.attr %{buildroot}%{_rpmconfigdir}/fileattrs/nodejs_abi.attr
install -pm0755 nodejs.prov %{buildroot}%{_rpmconfigdir}/nodejs.prov
install -pm0755 nodejs.req %{buildroot}%{_rpmconfigdir}/nodejs.req
install -pm0755 nodejs_abi.req %{buildroot}%{_rpmconfigdir}/nodejs_abi.req
install -pm0755 nodejs-symlink-deps %{buildroot}%{_rpmconfigdir}/nodejs-symlink-deps
install -pm0755 nodejs-fixdep %{buildroot}%{_rpmconfigdir}/nodejs-fixdep
install -pm0755 nodejs-setversion %{buildroot}%{_rpmconfigdir}/nodejs-setversion
install -Dpm0644 multiver_modules %{buildroot}%{_datadir}/node/multiver_modules
install -Dpm0755 nodejs-packaging-bundler %{buildroot}%{_bindir}/nodejs-packaging-bundler



%check
./test/run



%files
%license LICENSE
%{_rpmconfigdir}/macros.d/macros.nodejs
%{_rpmconfigdir}/fileattrs/nodejs*.attr
%{_rpmconfigdir}/nodejs*
%{_datadir}/node/multiver_modules

%files bundler
%{_bindir}/nodejs-packaging-bundler



%changelog
* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 2022.10-5
- Rebuilt for OpenCloudOS Stream 23.09

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 2022.10-4
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 2022.10-3
- Rebuilt for OpenCloudOS Stream 23

* Tue Jan 17 2023 Zhao Zhen <jeremiazhao@tencent.com> - 2022.10-2
- rearraged sorting number of source
- disabled bootstrap

* Fri Dec 30 2022 Zhao Zhen <jeremiazhao@tencent.com> - 2022.10-1
- initial
